ghc-7.4.2: The GHC API

Safe Haskell | None

TcCanonical

# Documentation

canonicalize :: Ct -> TcS StopOrContinue

canOccursCheck :: CtFlavor -> TcTyVar -> Xi -> TcS (Maybe Xi)

canEq :: SubGoalDepth -> CtFlavor -> EqVar -> Type -> Type -> TcS StopOrContinue

canEvVar :: EvVar -> PredTree -> SubGoalDepth -> CtFlavor -> TcS StopOrContinue

rewriteWithFunDeps :: [Equation] -> [Xi] -> WantedLoc -> TcS (Maybe ([Xi], [TcCoercion], [(EvVar, WantedLoc)]))

emitFDWorkAsWanted :: [(EvVar, WantedLoc)] -> SubGoalDepth -> TcS ()

emitFDWorkAsDerived :: [(EvVar, WantedLoc)] -> SubGoalDepth -> TcS ()

data StopOrContinue

Constructors

ContinueWith Ct |
Stop |

Instances

Outputable StopOrContinue |